import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Label;
import java.awt.Panel;

import quadbase.reportdesigner.designer.IReportIO;
import quadbase.reportdesigner.designer.QbReportDesigner;

//Run this example from Report Designer install directory
//Report manager must be running
public class RDWithTemplateFile extends Applet implements IReportIO {
	static final long serialVersionUID = 1;
	public QbReportDesigner designer;

	public static void main(java.lang.String[] args) {
		try {
			RDWithTemplateFile doReport = new RDWithTemplateFile();
			doReport.doReportDesignerApplet(null);
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	@Override
	public void init() {
		try {
			doReportDesignerApplet(this);
			setLayout(new BorderLayout());
			Panel panel = new Panel();
			panel.setLayout(new BorderLayout());
			panel.add("Center", new Label("LOADING"));
			add("Center", panel);
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	public void doReportDesignerApplet(Applet applet) throws Exception {

		// Connect to EspressManager
		QbReportDesigner.setServerAddress("127.0.0.1");
		QbReportDesigner.setServerPortNumber(22071);

		// Use images from jar file
		QbReportDesigner.setUseSysResourceImages(true);

		// Create a new QbReportDesigner instance
		designer = new QbReportDesigner(applet, "RDWithTemplateFile.rpt");

		// Overwrites default saveFile method
		designer.setReportIO(this);

		// Start Designer
		designer.setVisible(true);
	}

	// Save the file to a temp directory
	public void saveFile(byte[] data, String fileLocation) {

		System.out.println("OLD LOCATION: " + fileLocation);
		String newLoc = fileLocation.replace('/', '\\');
		int idx = newLoc.lastIndexOf("\\");
		newLoc = "temp/" + newLoc.substring(idx + 1);
		try {
			designer.writeFile(newLoc, data);
			System.out.println("NEW LOCATION: " + newLoc);
		} catch (Exception ex) {
			ex.printStackTrace();
		}
		designer.getDesigner().setTitle(newLoc);
		designer.getDesigner().repaint();

	}

}